var textWidth;  //Current page width
var textSize;   //Current text zoom

var currentBookmark = 0;        //The vertical scroll (in pixels) of the current bookmark
var currentBookmark_textWidth;  //The page width of the current bookmark
var currentBookmark_textSize;   //The text zoom of the current bookmark

var defaultTextSize;                  //Default text zoom
var defaultFontSize = 13;             //Default size of monotype font
var defaultFontType = "Courier New";  //Default font type for monotype

var bookmark_array;             //Array of all bookmark strings
var bookmark_array_index = -1;  //Index of current document in bookmark_array

var on = false;        //True when eReader view is active, false otherwise
var initDone = false;  //Set by init(), ensures init() only runs once

function init() {
	// This function is called only once, it creates default preferences if none exist
	initDone = true;
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
		if(!prefService.prefHasUserValue("extensions.ereader.textWidth"))
			prefService.setIntPref("extensions.ereader.textWidth", 800);

		if(!prefService.prefHasUserValue("extensions.ereader.textSize"))
			prefService.setIntPref("extensions.ereader.textSize", 150);

		if(!prefService.prefHasUserValue("extensions.ereader.bookmarks"))
			prefService.setCharPref("extensions.ereader.bookmarks", "");
	} catch (e) {}
}

function eReaderShutdown() {
	// This function is called when the browser window closes
	resetMonospaceFont();
	if (on) hideEReader();
}

function loadPreferences() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
		// Load zoom and page size
		textWidth = prefService.getIntPref("extensions.ereader.textWidth");
		textSize = prefService.getIntPref("extensions.ereader.textSize");

		// Load bookmark if one exists
		if (bookmark_array_index == -1) {
			var bookmark_str = prefService.getCharPref("extensions.ereader.bookmarks");
			bookmark_array = bookmark_str.split('|');
			bookmark_array_index = findIndex();

			if (bookmark_array_index < bookmark_array.length) {
				var start = bookmark_array[bookmark_array_index].indexOf('=') + 1;
				var temp = bookmark_array[bookmark_array_index].substring(start,bookmark_array[bookmark_array_index].length);
				var temp_array = temp.split(",");
				//if (parseInt(temp_array[0]) > 0 && confirm("Would you resume reading from where you left off?")) {
				if (parseInt(temp_array[0]) > 0) {
					currentBookmark = parseInt(temp_array[0]);
					textWidth = parseInt(temp_array[1]);
					textSize = parseInt(temp_array[2]);
				}
			}
		}

		currentBookmark_textWidth = textWidth;
		currentBookmark_textSize = textSize;
	} catch (e) {}
}

function savePreferences() {
	// Prepare bookmark
	var file = gBrowser.mCurrentBrowser.currentURI.spec;

	if (currentBookmark != 0) bookmark_array[bookmark_array_index] = file + "=" + currentBookmark + "," + textWidth + "," + textSize;

	var bookmark_str = bookmark_array.join('|');

	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
    	prefService.setIntPref("extensions.ereader.textWidth", textWidth);

    	textSize = gBrowser.markupDocumentViewer.textZoom * 100;
    	prefService.setIntPref("extensions.ereader.textSize", textSize);

		prefService.setCharPref("extensions.ereader.bookmarks", bookmark_str);
	} catch (e) {}
}

function findIndex() {
	// Search for file name in array
	file = gBrowser.mCurrentBrowser.currentURI.spec;
	for (var loop=0; loop < bookmark_array.length; loop++)
	{
	    if (bookmark_array[loop].indexOf(file) > -1) return loop;
	}
	return bookmark_array.length;
}

function toggleEReader()
{
	// Run init once and only once
	if (!initDone) init();

	newstate = 'false';
	on = false;

	state = document.getElementById('ereader-button').getAttribute('checked');

	if (state == 'false') {
		newstate = 'true';
		on = true;
	}
	state = document.getElementById('ereader-button').setAttribute('checked',newstate);

	if (on) showEReader();
	else hideEReader();
}

function showEReader()
{
	// Load settings
	loadPreferences();
	adjustMonospaceFont();

	defaultTextSize = gBrowser.markupDocumentViewer.textZoom;
	gBrowser.markupDocumentViewer.textZoom = textSize/100;

	// Show eReader elements and hide Firefox ones
	document.getElementById('leftSpace').setAttribute('hidden','false');
	document.getElementById('rightSpace').setAttribute('hidden','false');
	document.getElementById('ereader-bar').setAttribute('hidden','false');
	document.getElementById('nav-bar').setAttribute('hidden','true');
	document.getElementById('PersonalToolbar').setAttribute('hidden','true');
	document.getElementById('customToolbars').setAttribute('hidden','true');
	document.getElementById('appcontent').setAttribute('flex',0);
	document.getElementById('appcontent').setAttribute('width',textWidth);
	gotoBookmark();
}

function hideEReader()
{
	// Check if progress has been bookmarked
	if (gBrowser.mCurrentBrowser.contentWindow.scrollY != currentBookmark) {
		//if (confirm("Would you like to bookmark your progress?")) setBookmark();
		if (yesNoDialog("Set Bookmark?","Would you like to bookmark your progress?")) setBookmark();
	}

	savePreferences();

	// Hide eReader elements and show Firefox ones
	document.getElementById('leftSpace').setAttribute('hidden','true');
	document.getElementById('rightSpace').setAttribute('hidden','true');
	document.getElementById('ereader-bar').setAttribute('hidden','true');
	document.getElementById('nav-bar').setAttribute('hidden','false');
	document.getElementById('PersonalToolbar').setAttribute('hidden','false');
	document.getElementById('customToolbars').setAttribute('hidden','false');
	document.getElementById('appcontent').setAttribute('flex',1);

	currentBookmark = 0;
	bookmark_array_index = -1;

	// Restore original settings
	resetMonospaceFont();
	gBrowser.markupDocumentViewer.textZoom = defaultTextSize;
}

function isTextFile()
{
	var file = gBrowser.mCurrentBrowser.currentURI.spec;
	return (file.indexOf(".txt") != -1);
}

function adjustMonospaceFont()
{
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
		// Save old settings
		defaultFontSize = prefService.getIntPref("font.size.fixed.x-western");
		defaultFontType = prefService.getCharPref("font.name.monospace.x-western");

		if (isTextFile()) {
			// Set new font size
			prefService.setIntPref("font.size.fixed.x-western", prefService.getIntPref("font.size.variable.x-western"));

			// Set new monotype font
			if (prefService.getCharPref("font.default.x-western") == "serif")
				prefService.setCharPref("font.name.monospace.x-western", prefService.getCharPref("font.name.serif.x-western"));
			else prefService.setCharPref("font.name.monospace.x-western", prefService.getCharPref("font.name.sans-serif.x-western"));
		}
	} catch (e) {}
}

function resetMonospaceFont()
{
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
		// Restore old font settings
		prefService.setIntPref("font.size.fixed.x-western", defaultFontSize);
		prefService.setCharPref("font.name.monospace.x-western", defaultFontType);
	} catch (e) {}
}

function setWidth(increment) {
	// Increase the reading area by 'increment' (Note increment can be negative)
	textWidth+=increment;

	if (textWidth < 50) textWidth = 50;

	// Apply changes to screen and save for later
	text=document.getElementById('appcontent');
	text.setAttribute('width',textWidth);
	savePreferences();
}

function setTextSize(increment) {
	// Increase the text zoom by 'increment' (Note increment can be negative)
	textSize = gBrowser.markupDocumentViewer.textZoom * 100;
	textSize+=increment;

	if (textSize < 50) textSize = 50;

	// Apply changes to screen and save for later
	gBrowser.markupDocumentViewer.textZoom = textSize/100;
	savePreferences();
}

function gotoBookmark() {
	// Restore width and size of the bookmark
	textWidth = currentBookmark_textWidth;
	textSize = currentBookmark_textSize;

	text=document.getElementById('appcontent');
	text.setAttribute('width',textWidth);
	gBrowser.markupDocumentViewer.textZoom = textSize/100;

	// Scroll window to correct line (in pixels)
	gBrowser.mCurrentBrowser.contentWindow.scrollTo(0,currentBookmark);
}

function setBookmark() {
	// Save the current line (in pixels) for later
	currentBookmark = gBrowser.mCurrentBrowser.contentWindow.scrollY;
	savePreferences();

	// Save the current width and zoom
	currentBookmark_textWidth = textWidth;
	currentBookmark_textSize = textSize;

	alert("Your bookmark has been set.");
}

function yesNoDialog(title,prompt)
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var flags=promptService.BUTTON_TITLE_YES * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_NO * promptService.BUTTON_POS_1;

	try {
		// The flags set above are passed as the fourth argument. The next three arguments
		// are custom labels, and the last two arguments are for an optional check box.
		var out = promptService.confirmEx(window,title,prompt,flags, null, null, null, null, {});
		if (out == 0) return true;
		else return false;
	} catch(ex) {}
	return false;
}
